/**
 * Program Name: GetFileBean.java
 * Comments: Provides convenience methods for displaying an ASCII text file.
 * Assumes that the file is under the /WEB-INF directory of the calling
 * context.
 */

package extensions.generic;

import java.io.*;

public class GetFileBean {
    BufferedReader bin;
    PrintWriter out;
    String rootDir="";
    String fileName;

    public GetFileBean(){	
    }
    
    public String fileToString(String fileName){
	String s;
	fileName=rootDir+fileName;
	String fileString=" ";
	try {
	    bin=new BufferedReader(new FileReader(fileName));
	    while((s=bin.readLine())!=null) {
		fileString=fileString+s.trim()+"\n";
	    }
	}
	catch (Exception ex) {
	    System.err.println("Error opening file");
	    ex.printStackTrace();
	}
	return fileString;
    }
    
    /**
     * This method removes all control characters (like ^M) from the
     * string in the argument.  It returns the cleaned up string.
     * These can arise when going from DOS to Unix, and also apparently
     * get included in multiple lines in an HTML <textarea>.
     */
    public String removeCharacters(String scriptString,String filter){
	StringBuffer cleanedString=new StringBuffer();
	char ch;
	for(int i=0;i<scriptString.length();i++){
	    ch=scriptString.charAt(i);
	    if(filter.indexOf(ch)==-1)
		cleanedString.append(ch);
	}
	return cleanedString.toString();
    }

    /**
     * This method probably needs to be checked for compatibility 
     * between DOS and Unix.  
     */
    public void stringToFile(String scriptString, String fileName) {
	fileName=rootDir+fileName;
	try {
	    out=new PrintWriter(new FileWriter(fileName));
	    out.print(scriptString);
	    out.flush();
	    out.close();
	}
	catch (Exception ex) {
	    System.err.println("Can't open file for writing");
	    ex.printStackTrace();
	    out.flush();
	    out.close();
	}
    }
    public void setRootDir(String rootDir){
	this.rootDir=rootDir;
    }

    public String getRootDir(){
	return rootDir;
    }

}

