package extensions.generic;

import com.ibm.xml.*;
import com.ibm.xml.parser.*;
import com.ibm.xml.parsers.*;
import java.io.*;
import java.util.*;
import java.text.*;
import org.w3c.dom.*;
//import com.ibm.xml.framework.*;

public class parseGOW {

    Vector keyVec = new Vector(); // keyVec is the key vector.
    Vector valueVec = new Vector(); // valueVec is the value vector.
    String value = null;
    Hashtable hash = new Hashtable();

    public parseGOW() {
    }
    
    public int doParse(String xmlfilename){
	String key = null, value = null;
	String tagID = null;
	int nApplications = 0;

        if (xmlfilename == null) {
            System.err.println("Missing xmlfilename.");
            return nApplications;
        }
        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);

            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.err.println("Errors > zero");
                return(2);
            }
 
	    // Document is well-formed
            Document doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();

            Vector outerXSILTag = getAllTags(elem, "XSIL");
	    nApplications = outerXSILTag.size();
	    //	    System.out.println("The number of the outer XSIL: "+nApplications);
	    removeWhiteSpaceNodes(elem);
	    
	    Node nextnode = elem.getFirstChild();
	    Vector inXSILTags = getAllTags(nextnode, "XSIL");
	    nApplications = inXSILTags.size();
	    removeWhiteSpaceNodes((Element)nextnode);
	    
	    NodeList nodelist = elem.getChildNodes();
	    buildNodes(nodelist, tagID);
        } catch (Exception e) {
            e.printStackTrace();
        }
	// Make the hash table from the name/value pairs.
	for(int i = 0; i < keyVec.size(); i++){
	    hash.put(keyVec.get(i), (valueVec.get(i) + "+"));
	}
	//System.out.println("Hash Table = " + hash.toString());
	return nApplications;
    }

    
    public boolean removeApplication(String xmlfilename, String applName) {
	String tagID = null;
	boolean status = false;
	Document doc = null;

        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);

            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.err.println("Errors > zero");
		status = false;
                return status;
            }
            
	    // Document is well-formed	    
            doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();
	    removeWhiteSpaceNodes(elem);

	    /*
	    NodeList nodelist = elem.getChildNodes();
	    buildNodes(nodelist, tagID);
	    */

	    Node nextnode = elem.getFirstChild();
	    removeWhiteSpaceNodes((Element)nextnode);

	    Vector inXSILTags = getAllTags(nextnode, "XSIL");

	    int nAppl = inXSILTags.size();
	    for (int j = 0; j < nAppl; j++) {
		Node applNode = (Node)inXSILTags.elementAt(j);
		if( ((Element)applNode).getAttribute("Name").equals(applName)){
		    nextnode.removeChild(applNode);
		    status = true;
		}
	    }
	} catch (Exception e) {
	    System.err.println(e+" while removing the application" );
	    status = false;
	}

	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			  new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.err.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	return status;
    }


    /* 
       Hahtable (key/value)
       ===================
       key        |  value
       ===================
       applName   |
       -------------------
       paramNum   |
       -------------------
       outfileNum |
       -------------------
       iostyle    |
       -------------------
       hostName   |
       -------------------
       queueType  |
       -------------------
       execPath   |
       -------------------
       workDir    |
       -------------------
       qsubPath   |
       ===================
    */
    
    public boolean addApplication(String xmlfilename, Hashtable applData) {
	String tagID = null;
	boolean status = false;
	Document doc = null;  //new TXDocument();
	//Document doc = new Document();
	Element item, itemA, itemB;

        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);
	    
            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.err.println("Errors > zero");
		status = false;
                return status;
            }

            // Document is well-formed
            doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();
	    removeWhiteSpaceNodes(elem);

	    /*
	    NodeList nodelist = elem.getChildNodes();
	    buildNodes(nodelist, tagID);
	    */

	    Node nextnode = elem.getFirstChild();
	    removeWhiteSpaceNodes((Element)nextnode);

	    //  Make <User> element and add it
	    //  as a child of root
	    item = doc.createElement("XSIL");
	    item.setAttribute("Name",(String)applData.get("applName"));
	    item.setAttribute("Type","generic.parseXMLDesc");
	    
	    // Make <userID> element and add it
	    // as a child of User
	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfInParams");
	    itemA.appendChild(doc.createTextNode((String)applData.get("paramNum")));
	    item.appendChild(itemA);

	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfOutFiles");
	    itemA.appendChild(doc.createTextNode((String)applData.get("outfileNum")));
	    item.appendChild(itemA);

	    itemA=doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfInFiles");
	    itemA.appendChild(doc.createTextNode((String)applData.get("infileNum")));	    
	    item.appendChild(itemA);

	    itemA=doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfOutParam");
	    itemA.appendChild(doc.createTextNode((String)applData.get("outparamNum")));	    
	    item.appendChild(itemA);

	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","IOStyle");

	    itemA.appendChild(doc.createTextNode((String)applData.get("iostyle")));
	    item.appendChild(itemA);

	    // Make <primaryArea> element and add it
	    // as a child of User
	    itemA = doc.createElement("Table");
	    itemA.setAttribute("Name","HostList");

	    //  Make <title> element and add it
	    //  as a child of Person
	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","HostName");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","QueueType");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","ExecPath");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","WorkDir");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","QsubPath");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Stream");
	    itemB.setAttribute("Delimiter",",");

	    String hostName = (String)applData.get("hostName");
	    String queueType = (String)applData.get("queueType");
	    String execPath = (String)applData.get("execPath");
	    String workDir = (String)applData.get("workDir");
	    String qsubPath = (String)applData.get("qsubPath");

	    StringTokenizer sthostname = new StringTokenizer(hostName,"+");
	    StringTokenizer stqueuetype = new StringTokenizer(queueType,"+");
	    StringTokenizer stexecpath = new StringTokenizer(execPath,"+");
	    StringTokenizer stworkdir = new StringTokenizer(workDir,"+");
	    StringTokenizer stqsubpath = new StringTokenizer(qsubPath,"+");

	    String streamData = "";
	    while(sthostname.hasMoreTokens()) {
		//		System.out.println("has more tokens");
		String hntoken = sthostname.nextToken();
		String qttoken = stqueuetype.nextToken();
		String eptoken = stexecpath.nextToken();
		String wdtoken = stworkdir.nextToken();
		String qptoken = stqsubpath.nextToken();

		streamData += hntoken+","+qttoken+","+eptoken+","+wdtoken+","+qptoken+"\n";
	    }

	    itemB.appendChild(doc.createTextNode(streamData));
	    itemA.appendChild(itemB);
	    
	    //  Add <Person> as a child of <user>
	    item.appendChild(itemA);
	    
	    //  Add <contact> as a child of <user>
	    nextnode.insertBefore((Node)item, null);
	} catch (Exception e) {
	    System.err.println(e+" while adding the application" );
	    status = false;
	}
	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			   new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.err.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	return status;
    }


    public void removeWhiteSpaceNodes(Element parent) {
	Node nextNode = parent.getFirstChild();
        for (Node child = parent.getFirstChild(); nextNode != null;) {
	    child = nextNode;
	    nextNode = child.getNextSibling();
	    
            if (child instanceof TXText){
		if(((TXText)child).getIsIgnorableWhitespace()){
		    parent.removeChild(child);
		}
            } else if(child instanceof TXElement){
		removeWhiteSpaceNodes((Element)child);
	    }
	}
    }


    public void buildNodes(NodeList nl, String tagID){
	int indexnl = 0;
	boolean found = false;
	//System.out.println("Node Length: "+nl.getLength());

	while(indexnl < (nl.getLength())){
	    Node childNL = nl.item(indexnl);
	    String childName = childNL.getNodeName();
	    //	    System.out.println("Node Name: "+childName);

	    if(childName != "#text") {
		//System.out.println("Attribute Name: "+((Element)childNL).getAttribute("Name"));
		//System.out.println("Attribute Type: "+((Element)childNL).getAttribute("Type"));
		tagID = childName;
	    }
	    String childValue = childNL.getNodeValue();
	    if (childNL instanceof TXText) {
		childValue = childNL.getNodeValue();
		//System.out.println("Node Value: "+childValue);
	    } else if (childNL.hasChildNodes()){
		NodeList nextnodelist = childNL.getChildNodes();
		buildNodes(nextnodelist, tagID);
	    }
	    indexnl++;
	    if((tagID != null) && (childValue != null)) {
		if(keyVec.isEmpty() == true){
		    keyVec.addElement(tagID);
		    valueVec.addElement(childValue);
		    found = false;
		} else if(keyVec.isEmpty() != true){
		    for(int i = 0; i < keyVec.size(); i++){
			if (tagID.equals(keyVec.get(i))){
			    found = true;
			    value = (String)valueVec.get(i);
			    value = value + "+" + childValue;
			    valueVec.setElementAt(value, i);
			    break;
			}
		    }
		    if(found == false) {
			keyVec.addElement(tagID);
			valueVec.addElement(childValue);
			found = false;
		    }
		}
	    }
	}
    }
    

    private Vector getAllTags(Node node, String tag) {
	Vector result=new Vector();
	
	for(Node ch = node.getFirstChild(); ch!=null;
	    ch = ch.getNextSibling()) {
	    if(ch instanceof Element) {
		if(ch.getNodeName().equals(tag)) {
		    result.addElement(ch);
//  		    System.out.println("Node Name Tag: "+ch.getNodeName());
//  		    System.out.println("Attribute: "+((Element)ch).getAttribute("Name"));
		}
	    }
	}
	return result;
    }
}


